Non-Puppet proxies are shown in new host form Puppet proxy dropdowns
Description

When creating a new host, smart proxies without the Puppet or Puppet CA features are listed in the "Puppet Master" and "Puppet

CA" dropdown menus.

This seems to be an issue with the use of the "with_taxonomy_scope_override" scope as it forces an unscoped list of smart proxies,

which means we lose the filtered view of proxies with particular features:

app/helpers/hosts_and_hostgroups_helper.rb

52:    proxies = SmartProxy.with_features("Puppet CA").with_taxonomy_scope_override(@location,@org

anization)

 SmartProxy.with_features("Puppet CA") returns the Puppet CA proxies, but then calling .with_taxonomy_scope_override on that calls

unscoped so it becomes a list of all proxies, filtered by location + org.

Marking for 1.5.0 as it's a regression.

Related issues:

Related to Foreman - Bug #5660: All OS Mirrors are Shown in the Dropdown list Closed 05/10/2014

Associated revisions

Revision 50e0bc5c - 04/25/2014 11:02 AM - Dmitri Dolguikh 

fixes #5106: only puppet and puppet-ca proxies are now being shown on the 'new host' page

Revision 2afa8abd - 04/28/2014 11:51 AM - Dmitri Dolguikh 

fixes #5106: only puppet and puppet-ca proxies are now being shown on the 'new host' page

(cherry picked from commit 50e0bc5cea3a3406ffe94988d43a5915b1cd0717)

History

#1 - 04/09/2014 02:49 AM - Stephen Benjamin

This also happens with OS Media in hosts_and_hostgroups_helper.rb:

@operatingsystem.media.with_taxonomy_scope_override(@location,@organization)

#2 - 04/09/2014 08:44 AM - Lukas Zapletal

It looks like changing order of the clauses does help, but it does not look like a proper fix:

[12] pry(main)> SmartProxy.with_features("Puppet CA").with_taxonomy_scope_override(Location.first, Organizatio

n.first)

  Location Load (0.2ms)  SELECT "taxonomies".* FROM "taxonomies" WHERE "taxonomies"."type" IN ('Location') ORD

ER BY title LIMIT 1

  Organization Load (0.1ms)  SELECT "taxonomies".* FROM "taxonomies" WHERE "taxonomies"."type" IN ('Organizati

on') ORDER BY title LIMIT 1

   (0.1ms)  SELECT "taxable_taxonomies"."taxable_id" FROM "taxable_taxonomies" WHERE "taxable_taxonomies"."tax

able_type" = 'SmartProxy' AND "taxable_taxonomies"."taxonomy_id" IN (1)

   (0.1ms)  SELECT "taxable_taxonomies"."taxable_id" FROM "taxable_taxonomies" WHERE "taxable_taxonomies"."tax
able_type" = 'SmartProxy' AND "taxable_taxonomies"."taxonomy_id" IN (2)

   (0.1ms)  SELECT "taxable_taxonomies"."taxable_id" FROM "taxable_taxonomies" WHERE "taxable_taxonomies"."tax

able_type" = 'SmartProxy' AND "taxable_taxonomies"."taxonomy_id" IN (1)

   (0.1ms)  SELECT "taxable_taxonomies"."taxable_id" FROM "taxable_taxonomies" WHERE "taxable_taxonomies"."tax

able_type" = 'SmartProxy' AND "taxable_taxonomies"."taxonomy_id" IN (2)

  SmartProxy Load (0.1ms)  SELECT "smart_proxies".* FROM "smart_proxies" WHERE "smart_proxies"."id" IN (2) AND

 (1=1)

=> [#<SmartProxy id: 2, name: "localhost", url: "http://localhost:8443", created_at: "2013-11-29 12:41:16", up

dated_at: "2013-11-29 12:41:16">]

[13] pry(main)> 

[14] pry(main)> 

[15] pry(main)> 

[16] pry(main)> SmartProxy.with_taxonomy_scope_override(Location.first, Organization.first).with_features("Pup

pet CA")

  Location Load (0.2ms)  SELECT "taxonomies".* FROM "taxonomies" WHERE "taxonomies"."type" IN ('Location') ORD

ER BY title LIMIT 1

  Organization Load (0.1ms)  SELECT "taxonomies".* FROM "taxonomies" WHERE "taxonomies"."type" IN ('Organizati

on') ORDER BY title LIMIT 1

   (0.1ms)  SELECT "taxable_taxonomies"."taxable_id" FROM "taxable_taxonomies" WHERE "taxable_taxonomies"."tax

able_type" = 'SmartProxy' AND "taxable_taxonomies"."taxonomy_id" IN (1)

   (0.1ms)  SELECT "taxable_taxonomies"."taxable_id" FROM "taxable_taxonomies" WHERE "taxable_taxonomies"."tax

able_type" = 'SmartProxy' AND "taxable_taxonomies"."taxonomy_id" IN (2)

   (0.1ms)  SELECT "taxable_taxonomies"."taxable_id" FROM "taxable_taxonomies" WHERE "taxable_taxonomies"."tax

able_type" = 'SmartProxy' AND "taxable_taxonomies"."taxonomy_id" IN (1)

   (0.1ms)  SELECT "taxable_taxonomies"."taxable_id" FROM "taxable_taxonomies" WHERE "taxable_taxonomies"."tax

able_type" = 'SmartProxy' AND "taxable_taxonomies"."taxonomy_id" IN (2)

  SmartProxy Load (0.1ms)  SELECT "smart_proxies".* FROM "smart_proxies" INNER JOIN "features_smart_proxies" O

N "features_smart_proxies"."smart_proxy_id" = "smart_proxies"."id" INNER JOIN "features" ON "features"."id" = 

"features_smart_proxies"."feature_id" WHERE "smart_proxies"."id" IN (2) AND "features"."name" IN ('Puppet CA')

 AND (1=1)

=> []

#3 - 04/09/2014 11:13 AM - Dominic Cleal

I think that's an appropriate fix lzap, but it doesn't help with the associations case.

#4 - 04/10/2014 06:09 AM - Daniel Lobato Garcia

Can't we just change it to

SmartProxy.with_features("Puppet CA").with_taxonomy_scope(@location,@organization) 

 which doesn't call .unscoped?

#5 - 04/10/2014 08:15 AM - Dominic Cleal

Maybe, it looks like it's giving the right results in a quick check, though I still see it making SQL queries around my Organization.current which is a bit

worrying (the idea of the _override method is to ignore the current taxonomy), probably because .with_taxonomy_scope is called from the

default_scope still.

#6 - 04/10/2014 11:19 AM - Anonymous

I only see SmartProxy.with_taxonomy_scope use the location and organization that were passed in. Another difference between

with_taxonomy_scope and with_taxonomy_scope_override scopes is that the former retrieves all children while the latter retrieves all parents of the

organization and/or location that were passed in. I think we want the behaviour of SmartProxy.with_taxonomy_scope?

#7 - 04/10/2014 01:09 PM - Anonymous

Correction: with_taxonomy_scope will indeed overlap with the default scope if Location.current and Organization.current are set. This doesn't seem to

be a problem, however, as when multiple scopes are merged, duplicate attributes are removed, with the last one winning.

A couple of notes/questions:

- We may have bugs where with_taxonomy_scope is applied over the default scope.

- Perhaps it would be better (mostly for clarity/ease of maintenance sake) to explicitly call 'unscoped' in hosts_and_hostgroups_helper.rb (and similar)

before using with_taxonomy_scope, ie:

 

SmartProxy.unscoped.with_features("DNS").with_taxonomy_scope(Location.last, Organization.last)

#8 - 04/14/2014 03:09 PM - Anonymous

- Status changed from New to Assigned

- Assignee set to Anonymous
#9 - 04/15/2014 11:09 AM - Anonymous

- Status changed from Assigned to Ready For Testing

PR: https://github.com/theforeman/foreman/pull/1381

#10 - 04/15/2014 02:18 PM - Dominic Cleal

- Target version set to 1.8.4

#11 - 04/24/2014 10:22 AM - Anonymous

- Target version changed from 1.8.4 to 1.8.3

#12 - 04/24/2014 10:22 AM - Anonymous

- Target version changed from 1.8.3 to 1.8.4

#13 - 04/24/2014 10:25 AM - Anonymous

- Target version changed from 1.8.4 to 1.8.3

#14 - 04/25/2014 05:31 PM - Anonymous

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 50e0bc5cea3a3406ffe94988d43a5915b1cd0717.

#15 - 05/10/2014 07:27 AM - Stephen Benjamin

- Related to Bug #5660: All OS Mirrors are Shown in the Dropdown list added
